; 
;
; AUTOMATON includes by Nemeth Gabor/nemeth_g@freemail.hu (2004.09.16.)
;
; 

                AUTOMATON_FSM               EQU 0               ; Finite State Machine
                AUTOMATON_EFSM              EQU 1               ; Extended Finite State Machine
                AUTOMATON_ESSM              EQU 2               ; Extended Stack State Machine
                
                AUTOMAT_C_NORM              EQU 0		; Normal code
                AUTOMAT_C_INTV              EQU 1		; Interval codes


                CFSM                        EQU CAutomaton
              
; 
;
; The transition structure used with states
;
; -------------------------------------------------------------------------
STransition     STRUCT
                    CAtm_StateIn            dd ?
                    CAtm_Input              dd ?
                    CAtm_StateOut           dd ?
STransition     ENDS

; -------------------------------------------------------------------------

STransition2    STRUCT
                    CAtm_Input              dd ?
                    CAtm_StateOut           dd ?
                    CAtm_Action             dd ?
STransition2    ENDS

; -------------------------------------------------------------------------

STransition3    STRUCT
                    CAtm_Input              dd ?
                    CAtm_StackIn            dd ?
                    CAtm_StateOut           dd ?
                    CAtm_StackOut           dd ?
                    CAtm_Action             dd ?
STransition3    ENDS


; 
;
; The Cautomaton class used to simulate a FSM
;
; -------------------------------------------------------------------------
CAutomaton      STRUCT
                    CAtm_NextState_PTR      dd ?                ;pointer to "virtual function" NextState
                    CAtm_Type               dd ?                ;type property
                    CAtm_TransTable_PTR     dd ?                ;pointer to transition table
                    CAtm_AccStates_PTR      dd ?                ;number of states
                    CAtm_State              dd ?                ;state property
CAutomaton      ENDS


; 
;
; The CEFSM class used to simulate an EFSM
;
; -------------------------------------------------------------------------
CEFSM           STRUCT
                    CAtm_NextState_PTR      dd ?                ;pointer to "virtual function" NextState
                    CAtm_Type               dd ?                ;type property
                    CAtm_TransTable_PTR     dd ?                ;pointer to transition table
                    CAtm_AccStates_PTR      dd ?                ;number of states
CEFSM           ENDS


; 
;
; The Cautomaton class used to simulate an ESSM
;
; -------------------------------------------------------------------------
CESSM           STRUCT
                    CAtm_NextState_PTR      dd ?                ;pointer to "virtual function" NextState
                    CAtm_Type               dd ?                ;type property
                    CAtm_TransTable_PTR     dd ?                ;pointer to transition table
                    CAtm_AccStates_PTR      dd ?                ;number of states
                    CAtm_StackStart_PTR     dd ?                ;pointer to the stack start
                    CAtm_StackEnd_PTR       dd ?                ;pointer to the stack end
                    CAtm_Stack_PTR          dd ?                ;pointer to the current stack position
CESSM           ENDS


; 
;
; The functions
;
; 
;
; PUSH and POP macros for the stack state machine
;
; -------------------------------------------------------------------------
;
; IN:       esi:    address of CSSM
;
; OUT:      CF:     1 on fail (stack full)
;                   0 on success
; -------------------------------------------------------------------------
CAtm_PUSH       MACRO VAL:=<eax>
LOCAL @CAtm_PUSH
                ASSUME esi:PTR CESSM
                    push edi
                    mov edi,[esi].CAtm_Stack_PTR
                    sub edi,4
                    cmp edi,[esi].CAtm_StackEnd_PTR     ;at the end of stack?
                    jc @CAtm_PUSH
;PrintHex edi,'::PUSH:Stack PTR'
                    mov DWORD PTR [edi],VAL             ;no, then push
;PrintHex VAL,'::PUSH:Stack Val'
                    mov [esi].CAtm_Stack_PTR,edi        ;and increment
@CAtm_PUSH:
                    pop edi
                ENDM
; -------------------------------------------------------------------------
CAtm_POP        MACRO DST:=<eax>
LOCAL @CAtm_POP
                ASSUME esi:PTR CESSM
                    push edi
                    mov edi,[esi].CAtm_Stack_PTR
                    cmp edi,[esi].CAtm_StackStart_PTR   ;at the start of stack?
                    jnc @CAtm_POP
                    mov DST,DWORD PTR [edi]             ;no, then pop
;                    mov eax,DST
;PrintHex eax,'::POP:Stack Val'
                    add edi,4
                    mov [esi].CAtm_Stack_PTR,edi
;PrintHex edi,'::POP:Stack PTR'
                    stc
@CAtm_POP:
                    pop edi
                    cmc
                ENDM
; -------------------------------------------------------------------------

                    CAtm_Create         PROTO :DWORD,:DWORD,:DWORD,:DWORD
                    CAtm_Destroy        PROTO :DWORD
                    CAtm_Check          PROTO :DWORD

                    CFSM_NextState      PROTO
                    CEFSM_NextState     PROTO
                    CESSM_NextState     PROTO

; 