; 

    .486
    .model flat, stdcall
    .stack 0400h
    option casemap :none
 
    include \masm32\include\windows.inc

  ; -----------------------------------------------------------------
  ; include files that have MASM format prototypes for function calls
  ; -----------------------------------------------------------------
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\debug.inc

    include automat.inc


  ; ------------------------------------------------
  ; Library files that have definitions for function
  ; exports and tested reliable prebuilt code.
  ; ------------------------------------------------
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\debug.lib


; -------------------------------------------------------------------------
; States
; -------------------------------------------------------------------------
    State_A         EQU 0
    State_B         EQU 1
    State_C         EQU 2

    PUBLIC CAtm_EMPTY
    CAtm_EMPTY EQU  'NONE'
; -------------------------------------------------------------------------

; 
    .data
; -------------------------------------------------------------------------

        MyHeap              dd NULL
        TheInput_PTR        dd NULL
        Sep                 db 13,10," ------------------------------",13,10,0
        Text1               db 13,10,"    The input was ",0
        AcceptedTxt         db "accepted.",13,10,0
        RejectedTxt         db "rejected.",13,10,0
        Text2               db "    Input processed: ",0

; -------------------------------------------------------------------------

    include test.inc     ; The actions for the transitions

; -------------------------------------------------------------------------


; 
    .code                       ; Tell MASM where the code starts
; -------------------------------------------------------------------------
start:                          ; The CODE entry point to the program

; -------------------------------------------------------------------------
; Initializing
; -------------------------------------------------------------------------
            mov eax,FUNC(HeapCreate,HEAP_NO_SERIALIZE,65536,65536)
            .if eax == NULL
              print chr$("Not enough available memory!",13,10)
              exit
           .endif
            mov MyHeap,eax

; -------------------------------------------------------------------------
; Input
; -------------------------------------------------------------------------
            mov TheInput_PTR,input(13,10," Type input: ")

;PrintText '-START----------'
; -------------------------------------------------------------------------
; Test1
; -------------------------------------------------------------------------
;comment &
            invoke StdOut,ADDR Sep
            print chr$(" ** Test1: Creating an FSM...",13,10)
            invoke CAtm_Create,AUTOMATON_FSM,State_A,ADDR MyAccStates1,ADDR MyTransitions1
            call MainProc
; -------------------------------------------------------------------------
; Test2
; -------------------------------------------------------------------------
            invoke StdOut,ADDR Sep
            print chr$(" ** Test2: Creating an EFSM...",13,10)
            invoke CAtm_Create,AUTOMATON_EFSM,NULL,ADDR MyAccStates2,ADDR MyTransitions21
            call MainProc
;&
; -------------------------------------------------------------------------
; Test3
; -------------------------------------------------------------------------

comment &

lea eax,MyTransitions31
PrintHex eax,'MyTransitions31'
lea eax,MyTransitions32
PrintHex eax,'MyTransitions32'
lea eax,MyTransitions33
PrintHex eax,'MyTransitions33'
lea eax,MyTransitions34
PrintHex eax,'MyTransitions34'
lea eax,MyTransitions35
PrintHex eax,'MyTransitions35'

lea eax,Action21
PrintHex eax,'Action21'
lea eax,Action22
PrintHex eax,'Action22'

&

            invoke StdOut,ADDR Sep
            print chr$(" ** Test3: Creating an ESSM...",13,10)
            invoke CAtm_Create,AUTOMATON_ESSM,NULL,ADDR MyAccStates3,ADDR MyTransitions31
            call MainProc

          ASSUME esi:nothing
;PrintText '-END------------'
            exit


; -------------------------------------------------------------------------
; Main function - does the common part of the tests.
; -------------------------------------------------------------------------
MainProc    PROC
          ASSUME esi:PTR CAutomaton
            mov ebx,TheInput_PTR
@Main:
            xor eax,eax
            mov al,[ebx]                    ;load the input
            test eax,eax                    ;end of string/input?
            jnz @InputOk
            dec ebx                         ;read the end again
            mov eax,CAtm_EMPTY              ;empty input
@InputOk:
            call [esi].CAtm_NextState_PTR
            jc @Check                       ;c=1 if no transition found or user wanted to abort
            inc ebx
            jmp @Main
; -------------------------------------------------------------------------
@Check:
            invoke StdOut,ADDR Text1
            invoke CAtm_Check,esi           ;Check the result
            jnc @Rejected
            
            invoke StdOut,ADDR AcceptedTxt
            jmp @End
@Rejected:
            invoke StdOut,ADDR RejectedTxt
@End:
            invoke StdOut,ADDR Text2
            mov [ebx+1],BYTE PTR 0
            invoke StdOut,TheInput_PTR
            print chr$(13,10)

            print chr$(13,10," ** Destroying the automaton...")
            invoke CAtm_Destroy,esi
            invoke StdOut,ADDR Sep
            ret
MainProc    ENDP

; 
end start                       ; Tell MASM where the program ends
